<!--
  ~ Copyright 2000-2013 JetBrains s.r.o.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->
<component>
  <actions>

    <group id="SwitchViewActions">
      <action id="SwitchUp" class="com.intellij.ui.switcher.SwitchAction$Up"/>
      <action id="SwitchDown" class="com.intellij.ui.switcher.SwitchAction$Down"/>
      <action id="SwitchLeft" class="com.intellij.ui.switcher.SwitchAction$Left"/>
      <action id="SwitchRight" class="com.intellij.ui.switcher.SwitchAction$Right"/>
      <action id="SwitchApply" class="com.intellij.ui.switcher.ApplySwitchAction"/>
    </group>

    <action id="ContextHelp" class="com.intellij.ide.actions.ContextHelpAction"/>
    <action id="RunGc" class="com.intellij.ide.actions.RunGcAction"/>
    <action id="ShowPopupMenu" class="com.intellij.ide.actions.ShowPopupMenuAction"/>
    <action id="ShowColorPicker" class="com.intellij.ui.ShowColorPickerAction" text="Show Color Picker"/>

    <action id="NextEditorTab" class="com.intellij.openapi.fileEditor.impl.SelectNextEditorTabAction"/>
    <action id="PreviousEditorTab" class="com.intellij.openapi.fileEditor.impl.SelectPreviousEditorTabAction"/>
    
    <action id="TextComponent.ClearAction" class="com.intellij.ui.ClearTextAction"/>
    <action id="Switcher" class="com.intellij.ide.actions.Switcher" text="Switcher"/>
    <action id="QuickDocCopy" class="com.intellij.codeInsight.documentation.actions.CopyQuickDocAction" use-shortcut-of="$Copy"/>
    <action id="EditSourceInNewWindow" class="com.intellij.ide.actions.EditSourceInNewWindowAction" />
    <action id="SearchEverywhere" class="com.intellij.ide.actions.SearchEverywhereAction" />

    <group id="TemplateParametersNavigation">
      <action id="NextTemplateParameter" class="com.intellij.codeInsight.completion.NextPrevParameterAction$Next" text="Next Parameter">
        <keyboard-shortcut first-keystroke="TAB" keymap="$default"/>
      </action>
      <action id="PrevTemplateParameter" class="com.intellij.codeInsight.completion.NextPrevParameterAction$Prev" text="Previous Parameter">
        <keyboard-shortcut first-keystroke="shift TAB" keymap="$default"/>
      </action>
    </group>

    <group id="EditorActions">
      <action id="EditorPageUp" class="com.intellij.openapi.editor.actions.PageUpAction"/>
      <action id="EditorPageDown" class="com.intellij.openapi.editor.actions.PageDownAction"/>
      <action id="EditorPageUpWithSelection" class="com.intellij.openapi.editor.actions.PageUpWithSelectionAction"/>
      <action id="EditorPageDownWithSelection" class="com.intellij.openapi.editor.actions.PageDownWithSelectionAction"/>
      <action id="EditorCopy" class="com.intellij.openapi.editor.actions.CopyAction" use-shortcut-of="$Copy"/>
      <action id="EditorCut" class="com.intellij.openapi.editor.actions.CutAction" use-shortcut-of="$Cut"/>
      <action id="EditorPaste" class="com.intellij.openapi.editor.actions.PasteAction" use-shortcut-of="$Paste"/>
      <action id="EditorPasteSimple" class="com.intellij.openapi.editor.actions.SimplePasteAction"/>
      <action id="EditorPasteFromX11" class="com.intellij.openapi.editor.actions.PasteFromX11Action"/>
      <action id="EditorDelete" class="com.intellij.openapi.editor.actions.DeleteAction" use-shortcut-of="$Delete"/>
      <action id="EditorBackSpace" class="com.intellij.openapi.editor.actions.BackspaceAction"/>
      <action id="EditorHungryBackSpace" class="com.intellij.openapi.editor.actions.HungryBackspaceAction"/>
      <action id="EditorMoveToPageTop" class="com.intellij.openapi.editor.actions.PageTopAction"/>
      <action id="EditorMoveToPageBottom" class="com.intellij.openapi.editor.actions.PageBottomAction"/>
      <action id="EditorMoveToPageTopWithSelection" class="com.intellij.openapi.editor.actions.PageTopWithSelectionAction"/>
      <action id="EditorMoveToPageBottomWithSelection" class="com.intellij.openapi.editor.actions.PageBottomWithSelectionAction"/>
      <action id="EditorEnter" class="com.intellij.openapi.editor.actions.EnterAction"/>
      <action id="EditorEscape" class="com.intellij.openapi.editor.actions.EscapeAction"/>
      <action id="EditorUp" class="com.intellij.openapi.editor.actions.MoveCaretUpAction"/>
      <action id="EditorDown" class="com.intellij.openapi.editor.actions.MoveCaretDownAction"/>
      <action id="EditorLeft" class="com.intellij.openapi.editor.actions.MoveCaretLeftAction"/>
      <action id="EditorRight" class="com.intellij.openapi.editor.actions.MoveCaretRightAction"/>
      <action id="EditorUpWithSelection" class="com.intellij.openapi.editor.actions.MoveCaretUpWithSelectionAction"/>
      <action id="EditorDownWithSelection" class="com.intellij.openapi.editor.actions.MoveCaretDownWithSelectionAction"/>
      <action id="EditorLeftWithSelection" class="com.intellij.openapi.editor.actions.MoveCaretLeftWithSelectionAction"/>
      <action id="EditorRightWithSelection" class="com.intellij.openapi.editor.actions.MoveCaretRightWithSelectionAction"/>
      <action id="EditorUnindentSelection" class="com.intellij.openapi.editor.actions.UnindentSelectionAction"/>
      <action id="EditorTab" class="com.intellij.openapi.editor.actions.TabAction"/>
      <action id="EditorResetFontSize" class="com.intellij.openapi.editor.actions.ResetFontSizeAction"/>
      <action id="EditorScrollUp" class="com.intellij.openapi.editor.actions.ScrollUpAction"/>
      <action id="EditorScrollDown" class="com.intellij.openapi.editor.actions.ScrollDownAction"/>
      <action id="EditorScrollUpAndMove" class="com.intellij.openapi.editor.actions.ScrollUpAndMoveAction"/>
      <action id="EditorScrollDownAndMove" class="com.intellij.openapi.editor.actions.ScrollDownAndMoveAction"/>
      <action id="EditorScrollRight" class="com.intellij.openapi.editor.actions.ScrollRightAction"/>
      <action id="EditorScrollLeft" class="com.intellij.openapi.editor.actions.ScrollLeftAction"/>
      <action id="EditorScrollTop" class="com.intellij.openapi.editor.actions.ScrollToTopAction"/>
      <action id="EditorScrollBottom" class="com.intellij.openapi.editor.actions.ScrollToBottomAction"/>
      <action id="EditorMoveUpAndScroll" class="com.intellij.openapi.editor.actions.MoveUpAndScrollAction"/>
      <action id="EditorMoveDownAndScroll" class="com.intellij.openapi.editor.actions.MoveDownAndScrollAction"/>
      <action id="EditorMoveUpAndScrollWithSelection" class="com.intellij.openapi.editor.actions.MoveUpWithSelectionAndScrollAction"/>
      <action id="EditorMoveDownAndScrollWithSelection" class="com.intellij.openapi.editor.actions.MoveDownWithSelectionAndScrollAction"/>
      <action id="EditorAddOrRemoveCaret" class="com.intellij.openapi.editor.actions.AddOrRemoveCaretDummyAction"/>
      <action id="EditorCloneCaretBelow" class="com.intellij.openapi.editor.actions.CloneCaretBelow"/>
      <action id="EditorCloneCaretAbove" class="com.intellij.openapi.editor.actions.CloneCaretAbove"/>
      <action id="EditorToggleStickySelection" class="com.intellij.openapi.editor.actions.ToggleStickySelectionModeAction"/>
      <action id="EditorSwapSelectionBoundaries" class="com.intellij.openapi.editor.actions.SwapSelectionBoundariesAction"/>
      <action id="EditorLineStart" class="com.intellij.openapi.editor.actions.LineStartAction"/>
      <action id="EditorLineEnd" class="com.intellij.openapi.editor.actions.LineEndAction"/>
      <action id="EditorCutLineBackward" class="com.intellij.openapi.editor.actions.CutLineBackwardAction"/>
      <action id="EditorCutLineEnd" class="com.intellij.openapi.editor.actions.CutLineEndAction"/>
      <action id="EditorDeleteToLineEnd" class="com.intellij.openapi.editor.actions.DeleteToLineEndAction"/>
      <action id="EditorTextStart" class="com.intellij.openapi.editor.actions.TextStartAction"/>
      <action id="EditorTextEnd" class="com.intellij.openapi.editor.actions.TextEndAction"/>
      <action id="EditorLineStartWithSelection" class="com.intellij.openapi.editor.actions.LineStartWithSelectionAction"/>
      <action id="EditorLineEndWithSelection" class="com.intellij.openapi.editor.actions.LineEndWithSelectionAction"/>
      <action id="EditorTextStartWithSelection" class="com.intellij.openapi.editor.actions.TextStartWithSelectionAction"/>
      <action id="EditorTextEndWithSelection" class="com.intellij.openapi.editor.actions.TextEndWithSelectionAction"/>
      <action id="EditorNextWord" class="com.intellij.openapi.editor.actions.NextWordAction"/>
      <action id="EditorNextWordInDifferentHumpsMode" class="com.intellij.openapi.editor.actions.NextWordInDifferentHumpsModeAction"/>
      <action id="EditorNextWordWithSelection" class="com.intellij.openapi.editor.actions.NextWordWithSelectionAction"/>
      <action id="EditorNextWordInDifferentHumpsModeWithSelection" class="com.intellij.openapi.editor.actions.NextWordInDifferentHumpsModeWithSelectionAction"/>
      <action id="EditorPreviousWord" class="com.intellij.openapi.editor.actions.PreviousWordAction"/>
      <action id="EditorPreviousWordInDifferentHumpsMode" class="com.intellij.openapi.editor.actions.PreviousWordInDifferentHumpsModeAction"/>
      <action id="EditorPreviousWordWithSelection" class="com.intellij.openapi.editor.actions.PreviousWordWithSelectionAction"/>
      <action id="EditorPreviousWordInDifferentHumpsModeWithSelection" class="com.intellij.openapi.editor.actions.PreviousWordInDifferentHumpsModeWithSelectionAction"/>
      <action id="EditorDeleteToWordStart" class="com.intellij.openapi.editor.actions.DeleteToWordStartAction"/>
      <action id="EditorDeleteToWordStartInDifferentHumpsMode" class="com.intellij.openapi.editor.actions.DeleteToWordStartInDifferentHumpsModeAction"/>
      <action id="EditorDeleteToWordEnd" class="com.intellij.openapi.editor.actions.DeleteToWordEndAction"/>
      <action id="EditorDeleteToWordEndInDifferentHumpsMode" class="com.intellij.openapi.editor.actions.DeleteToWordEndInDifferentHumpsModeAction"/>
      <action id="EditorDeleteLine" class="com.intellij.openapi.editor.actions.DeleteLineAction"/>
      <action id="EditorKillToWordStart" class="com.intellij.openapi.editor.actions.KillToWordStartAction"/>
      <action id="EditorKillToWordEnd" class="com.intellij.openapi.editor.actions.KillToWordEndAction"/>
      <action id="EditorKillRegion" class="com.intellij.openapi.editor.actions.KillRegionAction"/>
      <action id="EditorKillRingSave" class="com.intellij.openapi.editor.actions.KillRingSaveAction"/>
      <action id="EditorDuplicate" class="com.intellij.openapi.editor.actions.DuplicateAction"/>
      <action id="EditorDuplicateLines" class="com.intellij.openapi.editor.actions.DuplicateLinesAction"/>
      <action id="EditorToggleInsertState" class="com.intellij.openapi.editor.actions.ToggleInsertStateAction"/>
      <action id="EditorToggleColumnMode" class="com.intellij.openapi.editor.actions.ToggleColumnModeAction"/>
      <action id="EditorIncreaseFontSize" class="com.intellij.openapi.editor.actions.ChangeEditorFontSizeAction$IncreaseEditorFontSize"/>
      <action id="EditorDecreaseFontSize" class="com.intellij.openapi.editor.actions.ChangeEditorFontSizeAction$DecreaseEditorFontSize"/>

      <action id="EditorScrollToCenter" class="com.intellij.openapi.editor.actions.ScrollToCenterAction"/>
      <action id="EditorToggleCase" class="com.intellij.openapi.editor.actions.ToggleCaseAction"/>
      <action id="EditorJoinLines" class="com.intellij.openapi.editor.actions.JoinLinesAction"/>
      <action id="FillParagraph" class="com.intellij.codeInsight.editorActions.fillParagraph.FillParagraphAction"/>
      <action id="EditorSelectLine" class="com.intellij.openapi.editor.actions.SelectLineAction"/>
      <action id="EditorSplitLine" class="com.intellij.openapi.editor.actions.SplitLineAction"/>
      <action id="EditorStartNewLine" class="com.intellij.openapi.editor.actions.StartNewLineAction"/>
      <action id="EditorStartNewLineBefore" class="com.intellij.openapi.editor.actions.StartNewLineBeforeAction"/>
    </group>

    <action id="ExpandAll" class="com.intellij.ide.actions.ExpandAllAction" icon="AllIcons.Actions.Expandall"/>
    <action id="CollapseAll" class="com.intellij.ide.actions.CollapseAllAction" icon="AllIcons.Actions.Collapseall"/>
    <action id="ExportToTextFile" class="com.intellij.ide.actions.ExportToTextFileAction" icon="AllIcons.Actions.Export"/>
    <action id="ExpandTreeNode" class="com.intellij.ide.actions.tree.ExpandTreeNodeAction"/>
    <action id="CollapseTreeNode" class="com.intellij.ide.actions.tree.CollapseTreeNodeAction"/>
    <action id="FullyExpandTreeNode" class="com.intellij.ide.actions.tree.FullyExpandTreeNodeAction"/>

    <action id="NextDiff" class="com.intellij.openapi.diff.actions.NextDiffAction" icon="AllIcons.Actions.MoveDown"/>
    <action id="PreviousDiff" class="com.intellij.openapi.diff.actions.PreviousDiffAction" icon="AllIcons.Actions.MoveUp"/>

    <action id="Refresh" class="com.intellij.ide.actions.RefreshAction"/>

    <action id="CompareTwoFiles" class="com.intellij.openapi.diff.actions.CompareFiles"/>
    <action id="CompareFileWithEditor" class="com.intellij.openapi.diff.actions.CompareFileWithEditor"/>
    <action id="CompareDirs" class="com.intellij.openapi.diff.actions.CompareDirectoriesAction" text="Compare Directories"/>
    <action id="CompareJars" class="com.intellij.openapi.diff.actions.CompareJarsAction" text="Compare Jars" use-shortcut-of="CompareDirs"/>

    <action id="ScrollTreeToCenter" class="com.intellij.ide.actions.ScrollTreeToCenterAction" use-shortcut-of="EditorScrollToCenter"/>

    <action id="PinToolwindowTab" class="com.intellij.ui.content.tabs.PinToolwindowTabAction"/>

    <action id="CloseEditor" class="com.intellij.ide.actions.CloseEditorAction"/>

    <action id="WelcomeScreen.ReopenRecent" class="com.intellij.openapi.wm.impl.welcomeScreen.RecentProjectsAction"/>

    <group id="MainMenu">
      <group id="FileMenu" popup="true">
        <group id="FileOpenGroup">
          <action id="NewDummyProject" class="com.intellij.ide.actions.NewDummyProjectAction" text="New Dummy Project" internal="true"/>
          <action id="OpenFile" class="com.intellij.ide.actions.OpenFileAction" icon="AllIcons.Actions.Menu_open"/>
          <group id="$LRU" class="com.intellij.ide.actions.RecentProjectsGroup" popup="true"/>
          <action id="CloseProject" class="com.intellij.ide.actions.CloseProjectAction"/>
        </group>
        <separator/>
        <group id="FileMainSettingsGroup">
          <action id="ShowSettings" class="com.intellij.ide.actions.ShowSettingsAction"/>
          <group id="FileOtherSettingsGroup" class="com.intellij.ide.actions.SmartPopupActionGroup">
             <action id="TemplateProjectProperties" class="com.intellij.ide.actions.TemplateProjectPropertiesAction"/>
             <group id="FileSettingsGroup"/>
          </group>
          <separator/>
          <group id="ExportImportGroup">
            <action id="ImportSettings" class="com.intellij.ide.actions.ImportSettingsAction"/>
            <action id="ExportSettings" class="com.intellij.ide.actions.ExportSettingsAction"/>
          </group>
        </group>
        <separator/>
        <action id="SaveAll" class="com.intellij.ide.actions.SaveAllAction" icon="AllIcons.Actions.Menu_saveall"/>
        <action id="Synchronize" class="com.intellij.ide.actions.SynchronizeAction" icon="AllIcons.Actions.Refresh"/>
        <action id="InvalidateCaches" class="com.intellij.ide.actions.InvalidateCachesAction"/>
        
        <action id="ChangeFileEncodingAction" class="com.intellij.openapi.vfs.encoding.ChangeFileEncodingAction"/>
        
        <group id="ChangeLineSeparators" text="Line Separators" popup="true" class="com.intellij.ide.actions.NonTrivialActionGroup">
          <action id="ConvertToWindowsLineSeparators" class="com.intellij.codeStyle.ConvertToWindowsLineSeparatorsAction"/>
          <action id="ConvertToUnixLineSeparators" class="com.intellij.codeStyle.ConvertToUnixLineSeparatorsAction"/>
          <action id="ConvertToMacLineSeparators" class="com.intellij.codeStyle.ConvertToMacLineSeparatorsAction"/>
        </group>

        <action id="ToggleReadOnlyAttribute" class="com.intellij.ide.actions.ToggleReadOnlyAttributeAction"/>
        <separator/>
        <action id="Exit" class="com.intellij.ide.actions.ExitAction"/>
      </group>

      <!-- Edit -->
      <group id="EditMenu" popup="true">
        <action id="$Undo" class="com.intellij.ide.actions.UndoAction" icon="AllIcons.Actions.Undo" text="Undo"/>
        <action id="$Redo" class="com.intellij.ide.actions.RedoAction" icon="AllIcons.Actions.Redo" text="Redo"/>
        <separator/>
        <group id="CutCopyPasteGroup">
          <action id="$Cut" class="com.intellij.ide.actions.CutAction" icon="AllIcons.Actions.Menu_cut"/>
          <action id="$Copy" class="com.intellij.ide.actions.CopyAction" icon="AllIcons.Actions.Copy"/>
          <action id="CopyPaths" class="com.intellij.ide.actions.CopyPathsAction"/>
          <action id="$Paste" class="com.intellij.ide.actions.PasteAction" icon="AllIcons.Actions.Menu_paste"/>
          <action id="PasteMultiple" class="com.intellij.openapi.editor.actions.MultiplePasteAction"/>
          <reference ref="EditorPasteSimple"/>
        </group>
        <group id="EditCreateDeleteGroup">
          <action id="$Delete" class="com.intellij.ide.actions.DeleteAction"/>
        </group>
        <separator/>
        <group id="FindMenuGroup" popup="true">
          <action id="Find" class="com.intellij.openapi.editor.actions.IncrementalFindAction" icon="AllIcons.Actions.Menu_find"/>
          <action id="Replace" class="com.intellij.openapi.editor.actions.ReplaceAction" icon="AllIcons.Actions.Menu_replace"/>
          <action id="FindNext" class="com.intellij.ide.actions.SearchAgainAction"/>
          <action id="FindPrevious" class="com.intellij.ide.actions.SearchBackAction"/>
          <action id="FindWordAtCaret" class="com.intellij.openapi.editor.actions.FindWordAtCaretAction"/>
          <action id="SelectAllOccurrences" class="com.intellij.openapi.editor.actions.SelectAllOccurrencesAction"/>
          <action id="SelectNextOccurrence" class="com.intellij.openapi.editor.actions.SelectNextOccurrenceAction"/>
          <action id="UnselectPreviousOccurrence" class="com.intellij.openapi.editor.actions.UnselectPreviousOccurrenceAction"/>
          <separator/>
          <action id="FindInPath" class="com.intellij.find.actions.FindInPathAction"/>
          <action id="ReplaceInPath" class="com.intellij.find.actions.ReplaceInPathAction"/>
          <separator/>
          <action id="FindUsages" class="com.intellij.find.actions.FindUsagesAction"/>
          <action id="ShowSettingsAndFindUsages" class="com.intellij.find.actions.FindUsagesAction$ShowSettingsAndFindUsages"/>
          <action id="ShowUsages" class="com.intellij.find.actions.ShowUsagesAction"/>
          <action id="FindUsagesInFile" class="com.intellij.find.actions.FindUsagesInFileAction"/>
          <action id="HighlightUsagesInFile" class="com.intellij.codeInsight.highlighting.actions.HighlightUsagesAction"/>
          <group id="ShowRecentFindUsagesGroup" class="com.intellij.find.impl.ShowRecentFindUsagesGroup" popup="true"/>
        </group>
        <group id="Macros" popup="true">
          <group id="StandardMacroActions">
            <action id="PlaybackLastMacro" class="com.intellij.ide.actionMacro.actions.PlaybackLastMacroAction"/>
            <action id="StartStopMacroRecording" class="com.intellij.ide.actionMacro.actions.StartStopMacroRecordingAction"/>
            <action id="EditMacros" class="com.intellij.ide.actionMacro.actions.EditMacrosAction"/>
            <action id="PlaySavedMacrosAction" class="com.intellij.ide.actionMacro.actions.PlaySavedMacros"/>
          </group>
          <separator/>
          <group id="MacrosGroup" class="com.intellij.ide.actionMacro.actions.MacrosGroup"/>
        </group>
        <reference ref="EditorToggleColumnMode"/>
        <group id="EditSelectGroup">
          <action id="$SelectAll" class="com.intellij.ide.actions.SelectAllAction"/>
        </group>
        <separator/>
        <group id="EditSmartGroup">
          <reference ref="EditorJoinLines"/>
          <reference ref="FillParagraph"/>
          <reference ref="EditorDuplicate"/>
          <reference ref="EditorIndentSelection"/>
          <reference ref="EditorUnindentSelection"/>
          <reference ref="EditorToggleCase"/>
          <group id="ConvertIndentsGroup" popup="true">
            <action id="ConvertIndentsToSpaces" class="com.intellij.openapi.editor.actions.ConvertIndentsToSpacesAction"/>
            <action id="ConvertIndentsToTabs" class="com.intellij.openapi.editor.actions.ConvertIndentsToTabsAction"/>
          </group>
        </group>
        <reference ref="TemplateParametersNavigation"/>
      </group>

      <!-- View -->
      <group id="ViewMenu" popup="true" compact="true">
        <group id="ToolWindowsGroup" class="com.intellij.ide.actions.ToolWindowsGroup" popup="true"/>

        <action id="EditSource" class="com.intellij.ide.actions.EditSourceAction"/>
        <action id="ViewSource" class="com.intellij.ide.actions.ViewSourceAction"/>
        <separator/>
        <group id="ViewRecentActions">
          <action id="RecentFiles" class="com.intellij.ide.actions.ShowRecentFilesAction"/>
          <action id="RecentChangedFiles" class="com.intellij.ide.actions.ShowRecentlyEditedFilesAction"/>
        </group>
        <separator/>
        <group id="CompareActions">
          <group id="PairFileActions">
            <reference ref="CompareTwoFiles"/>
            <reference ref="CompareFileWithEditor"/>
          </group>
          <action id="CompareClipboardWithSelection" class="com.intellij.openapi.diff.actions.CompareClipboardWithSelection"/>
        </group>
        <separator/>
        <action id="QuickChangeScheme" class="com.intellij.ide.actions.QuickChangeSchemesAction"/>
        <group id="UIToggleActions">
          <separator/>
          <action id="ViewToolBar" class="com.intellij.ide.actions.ViewToolbarAction"/>
          <action id="ViewToolButtons" class="com.intellij.ide.actions.ViewToolWindowButtonsAction"/>
          <action id="ViewStatusBar" class="com.intellij.ide.actions.ViewStatusBarAction"/>
        </group>

        <group id="EditorToggleActions" popup="true">
          <action id="EditorToggleShowWhitespaces" class="com.intellij.openapi.editor.actions.ToggleShowWhitespacesAction"/>
          <action id="EditorToggleShowLineNumbers" class="com.intellij.openapi.editor.actions.ToggleShowLineNumbersAction"/>
          <action id="EditorToggleShowIndentLines" class="com.intellij.openapi.editor.actions.ToggleShowIndentLinesAction"/>
          <action id="EditorToggleUseSoftWraps" class="com.intellij.openapi.editor.actions.ToggleUseSoftWrapsMenuAction" icon="AllIcons.Actions.ToggleSoftWrap"/>
        </group>

        <!-- Mac OS Lion: In native apps toggle full screen mode is the last action in "View" menu -->
        <group id="ToggleFullScreenGroup">
          <separator/>
          <action id="TogglePresentationMode" class="com.intellij.ide.actions.TogglePresentationModeAction"/>
          <action id="ToggleFullScreen" class="com.intellij.ide.actions.ToggleFullScreenAction"/>
        </group>
      </group>

      <!-- Go to -->
      <group id="GoToMenu" popup="true">
        <action id="GotoLine" class="com.intellij.ide.actions.GotoLineAction"/>
        <separator/>
        <action id="Back" class="com.intellij.ide.actions.BackAction" icon="AllIcons.Actions.Back"/>
        <action id="Forward" class="com.intellij.ide.actions.ForwardAction" icon="AllIcons.Actions.Forward"/>
        <action id="JumpToLastChange" class="com.intellij.ide.actions.JumpToLastEditAction"/>
        <separator/>
        <action id="PreviousOccurence" class="com.intellij.ide.actions.PreviousOccurenceAction" icon="AllIcons.Actions.PreviousOccurence"/>
        <action id="NextOccurence" class="com.intellij.ide.actions.NextOccurenceAction" icon="AllIcons.Actions.NextOccurence"/>
        <separator/>
      </group>

      <!-- Tools -->
      <group id="ToolsMenu" configurable="true" popup="true" compact="true">
        <action id="PsiViewer" class="com.intellij.internal.psiView.PsiViewerAction"/>
        <action id="PsiViewerForContext" class="com.intellij.internal.psiView.PsiViewerForContextAction"/>
        <separator/>
        <action id="CreateLauncherScript" class="com.intellij.ide.actions.CreateLauncherScriptAction"/>
        <action id="CreateDesktopEntry" class="com.intellij.ide.actions.CreateDesktopEntryAction"/>
        <separator/>
      </group>

      <group id="WindowMenu" popup="true">
        <action id="MinimizeCurrentWindow" class="com.intellij.ide.actions.MinimizeCurrentWindowAction"/>
        <action id="StoreDefaultLayout" class="com.intellij.ide.actions.StoreDefaultLayoutAction"/>
        <action id="RestoreDefaultLayout" class="com.intellij.ide.actions.RestoreDefaultLayoutAction"/>
        <separator/>
        <group id="ActiveToolwindowGroup" popup="true">
          <action id="HideActiveWindow" class="com.intellij.ide.actions.HideToolWindowAction"/>
          <action id="HideSideWindows" class="com.intellij.ide.actions.HideSideWindowsAction"/>
          <action id="HideAllWindows" class="com.intellij.ide.actions.HideAllToolWindowsAction"/>
          <action id="CloseActiveTab" class="com.intellij.ide.actions.CloseActiveTabAction"/>
          <action id="JumpToLastWindow" class="com.intellij.ide.actions.JumpToLastWindowAction"/>
          <separator/>
          <action id="TogglePinnedMode" class="com.intellij.ide.actions.TogglePinnedModeAction"/>
          <action id="ToggleDockMode" class="com.intellij.ide.actions.ToggleDockModeAction"/>
          <action id="ToggleFloatingMode" class="com.intellij.ide.actions.ToggleFloatingModeAction"/>
          <action id="ToggleSideMode" class="com.intellij.ide.actions.ToggleSideModeAction"/>
          <action id="ToggleContentUiTypeMode" class="com.intellij.ide.actions.ToggleContentUiTypeAction"/>
          <action id="ShowContent" class="com.intellij.ide.actions.ShowContentAction"/>
          <group id="ResizeToolWindowGroup" popup="true">
            <action id="ResizeToolWindowLeft" class="com.intellij.ide.actions.ResizeToolWindowAction$Left"/>
            <action id="ResizeToolWindowRight" class="com.intellij.ide.actions.ResizeToolWindowAction$Right"/>
            <action id="ResizeToolWindowUp" class="com.intellij.ide.actions.ResizeToolWindowAction$Up"/>
            <action id="ResizeToolWindowDown" class="com.intellij.ide.actions.ResizeToolWindowAction$Down"/>
          </group>
        </group>

        <group id="EditorTabsGroup" popup="true">
          <action id="NextTab" class="com.intellij.ide.actions.NextTabAction"/>
          <action id="PreviousTab" class="com.intellij.ide.actions.PreviousTabAction"/>
          <action id="PinActiveTab" class="com.intellij.ide.actions.PinActiveTabAction"/>
          <action id="TabList" class="com.intellij.ide.actions.TabListAction"/>
          <separator/>
          <group id="CloseEditorsGroup">
            <action id="CloseContent" class="com.intellij.ide.actions.CloseAction"/>
            <action id="CloseAllEditorsButActive" class="com.intellij.ide.actions.CloseAllEditorsButActiveAction"/>
            <action id="CloseAllEditors" class="com.intellij.ide.actions.CloseAllEditorsAction"/>
            <action id="CloseAllUnpinnedEditors" class="com.intellij.ide.actions.CloseAllUnpinnedEditorsAction"/>
          </group>
          <separator/>
          <action id="ReopenClosedTab" class="com.intellij.openapi.fileEditor.impl.ReopenClosedTabAction" />
          <action id="SplitVertically" class="com.intellij.ide.actions.SplitVerticallyAction" icon="AllIcons.Actions.SplitVertically"/>
          <action id="SplitHorizontally" class="com.intellij.ide.actions.SplitHorizontallyAction" icon="AllIcons.Actions.SplitHorizontally"/>
          <action id="MoveTabRight" class="com.intellij.ide.actions.MoveTabRightAction"/>
          <action id="MoveTabDown" class="com.intellij.ide.actions.MoveTabDownAction"/>
          <action id="ChangeSplitOrientation" class="com.intellij.ide.actions.ChangeSplitterOrientationAction"/>
          <action id="Unsplit" class="com.intellij.ide.actions.UnsplitAction"/>
          <action id="UnsplitAll" class="com.intellij.ide.actions.UnsplitAllAction"/>
          <action id="NextSplitter" class="com.intellij.ide.actions.NextSplitAction"/>
          <action id="PrevSplitter" class="com.intellij.ide.actions.PrevSplitAction"/>
          <group id="TabsPlacementGroup" popup="true" text="Tabs Placement">
            <action id="TabsPlacementTop"    text="Top"    class="com.intellij.ide.actions.TabsPlacementAction$Top" />
            <action id="TabsPlacementBottom" text="Bottom" class="com.intellij.ide.actions.TabsPlacementAction$Bottom" />
            <action id="TabsPlacementLeft"   text="Left"   class="com.intellij.ide.actions.TabsPlacementAction$Left" />
            <action id="TabsPlacementRight"  text="Right"  class="com.intellij.ide.actions.TabsPlacementAction$Right" />
          </group>
          <action id="TabsAlphabeticalMode" class="com.intellij.ide.actions.TabsAlphabeticalModeSwitcher" text="Sort Tabs by Filename"/>
        </group>

        <group id="BackgroundTasks" popup="true">
          <action id="ShowProcessWindow" class="com.intellij.openapi.wm.impl.status.ShowProcessWindowAction"/>
          <action id="AutoShowProcessWindow" class="com.intellij.openapi.wm.impl.status.AutoShowProcessPopupAction"/>
        </group>

        <separator/>
        <group id="OpenProjectWindows" class="com.intellij.openapi.wm.impl.ProjectWindowActionGroup">
          <action id="NextProjectWindow" class="com.intellij.openapi.wm.impl.NextProjectWindow"/>
          <action id="PreviousProjectWindow" class="com.intellij.openapi.wm.impl.PreviousProjectWindow"/>
          <separator/>
        </group>
      </group>

      <!-- Help -->
      <group id="HelpMenu" popup="true">
        <action id="GotoAction" class="com.intellij.ide.actions.GotoActionAction"/>
        <separator/>
        <action id="HelpTopics" class="com.intellij.ide.actions.HelpTopicsAction" icon="AllIcons.Actions.Help"/>
        <action id="ShowTips" class="com.intellij.ide.actions.ShowTipsAction"/>
        <action id="ProductivityGude" class="com.intellij.featureStatistics.actions.ShowFeatureUsageStatisticsAction"/>
        <separator/>
        <action id="TechnicalSupport" class="com.intellij.ide.actions.TechnicalSupportAction"/>
        <action id="SendFeedback" class="com.intellij.ide.actions.SendFeedbackAction"/>
        <action id="LogDebugConfigure" class="com.intellij.ide.actions.DebugLogConfigureAction"/>
        <action id="ShowLog" class="com.intellij.ide.actions.ShowLogAction"/>
        <separator/>
        <action id="OnlineDocAction" class="com.intellij.ide.actions.OnlineDocAction"/>
        <action id="Help.KeymapReference" class="com.intellij.ide.actions.RefCardAction" icon="AllIcons.General.DefaultKeymap"/>
        <action id="Help.JetBrainsTV" class="com.intellij.openapi.wm.impl.welcomeScreen.JetBrainsTvAction"/>
        <separator/>
        <action id="CheckForUpdate" class="com.intellij.openapi.updateSettings.impl.CheckForUpdateAction"/>
        <action id="About" class="com.intellij.ide.actions.AboutAction"/>
      </group>

      <group id="OtherMenu" class="com.intellij.ide.actions.NonEmptyActionGroup"/>
    </group>

    <group id="MainToolBar" configurable="true">
      <reference ref="OpenFile"/>
      <reference ref="SaveAll"/>
      <reference ref="Synchronize"/>
      <separator/>
      <reference ref="$Undo"/>
      <reference ref="$Redo"/>
      <separator/>
      <reference ref="$Cut"/>
      <reference ref="$Copy"/>
      <reference ref="$Paste"/>
      <separator/>
      <reference ref="Back"/>
      <reference ref="Forward"/>
      <separator/>
      <group id="MainToolBarSettings">
        <reference ref="ShowSettings"/>
      </group>
      <separator/>
      <reference ref="HelpTopics"/>
      <reference ref="SearchEverywhere"/>
    </group>

    <group id="NavBarVcsGroup"/>

    <group id="EditorPopupMenu" configurable="true">
      <reference ref="$Cut"/>
      <reference ref="$Copy"/>
      <reference ref="$Paste"/>
      <reference ref="PasteMultiple"/>
      <reference ref="EditorPasteSimple"/>
      <reference ref="EditorToggleColumnMode"/>
      <action id="$SearchWeb" class="com.intellij.ide.actions.SearchWebAction"/>
      <separator/>
      <reference ref="CompareClipboardWithSelection"/>
      <reference ref="ChangeFileEncodingAction"/>
    </group>

    <group id="ConsoleEditorPopupMenu">
      <reference ref="CutCopyPasteGroup"/>
      <separator/>
      <reference ref="CompareClipboardWithSelection"/>
      <reference ref="$SearchWeb"/>
    </group>

    <group id="EditorTabPopupMenu">
      <reference ref="CloseEditorsGroup"/>
      <separator/>
      <reference ref="CopyPaths"/>
      <separator/>
      <reference ref="SplitVertically"/>
      <reference ref="SplitHorizontally"/>
      <reference ref="MoveTabRight"/>
      <reference ref="MoveTabDown"/>
      <action id="MoveEditorToOppositeTabGroup" class="com.intellij.openapi.fileEditor.impl.MoveEditorToOppositeTabGroupAction"/>
      <action id="OpenEditorInOppositeTabGroup" class="com.intellij.openapi.fileEditor.impl.OpenEditorInOppositeTabGroupAction"/>
      <reference ref="ChangeSplitOrientation"/>
      <reference ref="PinActiveTab"/>
      <reference ref="TabsPlacementGroup"/>
      <reference ref="TabsAlphabeticalMode"/>
      <separator/>
      <reference ref="NextTab"/>
      <reference ref="PreviousTab"/>
      <reference ref="ReopenClosedTab"/>
      <separator/>
      <reference ref="Unsplit"/>
      <reference ref="UnsplitAll"/>
    </group>

    <group id="WelcomeScreen.QuickStart">
    </group>

    <group id="WelcomeScreen.Documentation">
      <action id="WelcomeScreen.ReadHelp" class="com.intellij.ide.actions.HelpTopicsAction"
        icon="AllIcons.General.ReadHelp"/>
      <action id="WelcomeScreen.ShowTips" class="com.intellij.ide.actions.ShowTipsAction"
        icon="AllIcons.General.TipsOfTheDay"/>
      <reference ref="Help.KeymapReference"/>
    </group>

    <group id="WelcomeScreen.Configure">
      <action id="WelcomeScreen.Settings" class="com.intellij.ide.actions.ShowSettingsAction" icon="AllIcons.General.Configure"/>
      <action id="WelcomeScreen.Plugins" class="com.intellij.ide.actions.ShowPluginManagerAction" icon="AllIcons.General.PluginManager"/>

      <action id="WelcomeScreen.Configure.Import" class="com.intellij.ide.actions.ImportSettingsAction" icon="AllIcons.General.ImportSettings"/>
      <action id="WelcomeScreen.Configure.Export" class="com.intellij.ide.actions.ExportSettingsAction" icon="AllIcons.General.ExportSettings"/>

      <action id="WelcomeScreen.Configure.DesktopEntry" class="com.intellij.ide.actions.CreateDesktopEntryAction"
              icon="AllIcons.Welcome.CreateDesktopEntry"/>
    </group>

    <group id="FileChooser">
      <action id="FileChooser.TogglePathShowing" class="com.intellij.openapi.fileChooser.actions.TogglePathShowingAction"/>
    </group>

    <action id="Diff.FocusOppositePane" class="com.intellij.openapi.diff.actions.FocusOppositePaneAction"
      use-shortcut-of="NextSplitter"/>

    <group id="EditorGutterPopupMenu">
      <reference ref="EditorToggleShowLineNumbers"/>
      <reference ref="EditorToggleShowIndentLines" />
      <reference ref="EditorToggleUseSoftWraps" />
    </group>

    <group id="FileChooserToolbar">
      <action id="FileChooser.GotoHome" class="com.intellij.openapi.fileChooser.actions.GotoHomeAction"
        icon="AllIcons.Nodes.HomeFolder"/>
      <action id="FileChooser.GotoProject" class="com.intellij.openapi.fileChooser.actions.GotoProjectDirectory"
        icon="AllIcons.Nodes.IdeaProject"/>
      <separator/>
      <action id="FileChooser.NewFile" class="com.intellij.openapi.fileChooser.actions.NewFileAction"
        icon="AllIcons.Actions.New"/>
      <action id="FileChooser.NewFolder" class="com.intellij.openapi.fileChooser.actions.NewFolderAction"
        icon="AllIcons.Actions.NewFolder"/>
      <action id="FileChooser.Delete" class="com.intellij.openapi.fileChooser.actions.FileDeleteAction"
        icon="AllIcons.Actions.Delete"/>
      <separator/>
      <action id="FileChooser.Refresh" class="com.intellij.openapi.fileChooser.actions.RefreshFileChooserAction"
        icon="AllIcons.Actions.Refresh"/>
      <separator/>
      <action id="FileChooser.ShowHiddens" class="com.intellij.openapi.fileChooser.actions.ShowHiddensAction"
        icon="AllIcons.Actions.ShowHiddens"/>
    </group>

    <group id="DiffPanel.Toolbar">
      <reference ref="$Copy"/>
      <reference ref="PreviousDiff"/>
      <reference ref="NextDiff"/>
      <separator/>
      <action id="Diff.IgnoreWhitespace" class="com.intellij.openapi.diff.actions.IgnoreWhiteSpacesAction" text=""/>
      <separator/>
      <action id="Diff.HighlightMode" class="com.intellij.openapi.diff.actions.HighlightModeAction" text=""/>
    </group>

    <group id="ChangeScheme">
      <action id="ChangeColorScheme" class="com.intellij.ide.actions.QuickChangeColorSchemeAction"/>
      <action id="ChangeKeymap" class="com.intellij.ide.actions.QuickChangeKeymapAction"/>
      <action id="ChangeLaf" class="com.intellij.ide.actions.QuickChangeLookAndFeel"/>
    </group>

    <action id="MaintenanceAction" class="com.intellij.ide.actions.MaintenanceAction"/>

    <group id="MaintenanceGroup">
      <action id="UiDebugger" class="com.intellij.ui.debugger.ShowUiDebuggerAction"/>
      <action id="ShowRegistry" class="com.intellij.openapi.util.registry.ShowRegistryAction"/>
    </group>

    <action id="Console.Execute" class="com.intellij.openapi.actionSystem.EmptyAction"/>
    <action id="Console.SplitLine" class="com.intellij.openapi.actionSystem.EmptyAction"/>
    <group id="Console.HistoryActions">
      <action id="Console.History.Previous" class="com.intellij.openapi.actionSystem.EmptyAction"/>
      <action id="Console.History.Next" class="com.intellij.openapi.actionSystem.EmptyAction"/>
      <action id="Console.History.Browse" class="com.intellij.openapi.actionSystem.EmptyAction" icon="AllIcons.General.MessageHistory"/>
    </group>

    <group id="Internal" text="&amp;Internal Actions" internal="true" popup="true">
      <group id="Internal.Errors" popup="true" text="Exceptions">
        <action id="DropAnError" internal="true" class="com.intellij.diagnostic.DropAnErrorAction"/>
        <action id="DropAnErrorWithAttachments" internal="true" class="com.intellij.diagnostic.DropAnErrorWithAttachmentsAction"/>
        <action id="DropAnOutOfMemoryError" internal="true" class="com.intellij.diagnostic.DropAnOutOfMemoryErrorAction"/>
        <action id="DropAnOutOfPermGenMemoryError" internal="true" class="com.intellij.diagnostic.DropAnOutOfPermGenMemoryErrorAction"/>
      </group>
      <separator/>
      <action internal="true" id="ReloadProjectAction" class="com.intellij.internal.ReloadProjectAction"/>
      <action id="DumbMode" internal="true" class="com.intellij.internal.ToggleDumbModeAction" text="Dumb mode"/>
      <action id="LaggingMode" internal="true" class="com.intellij.internal.ToggleLaggingModeAction" text="Lagging mode"/>
      <separator/>
      <group id="Internal.UI" popup="true" text="&amp;UI">
        <action id="NotificationTestAction" internal="true" class="com.intellij.notification.impl.actions.NotificationTestAction"
                text="Add Test Notification"/>
        <action id="TestMessageBoxAction" internal="true" class="com.intellij.diagnostic.TestMessageBoxAction" text="Show Test Dialog"/>
        <separator/>
        <group id="Internal.focusAndModality" popup="true" text="Focus and modality testing">
          <action id="ManualMacMessagesTest" internal="true" class="com.intellij.internal.validation.MacMessagesTest"
                  text="Manual test for testing MacMessages"/>
          <action id="MacMessagesSequencesTest" internal="true" class="com.intellij.internal.validation.TestMacMessagesSequencesAction"
                  text="Test Mac Messages Sequences" />
        </group>
        <action id="FocusDebugger" internal="true" class="com.intellij.internal.focus.FocusDebuggerAction" text="Start Focus Debugger"/>
        <action id="FocusTracer" internal="true" class="com.intellij.internal.focus.FocusTracesAction" text="Start Focus Trace">
          <keyboard-shortcut first-keystroke="control shift F11" keymap="$default"/>
        </action>

        <action id="UiInspector" internal="true" class="com.intellij.internal.inspector.UiInspectorAction" text="UI &amp;Inspector"/>
        <action id="ShowSplash" internal="true" class="com.intellij.ui.ShowSplashAction" text="Show Splash" />
        <action id="ValidationTest" internal="true" class="com.intellij.internal.validation.TestDialogWithValidationAction" text="Validation Dialog Test" />
        <action id="MacMessagesTest" internal="true" class="com.intellij.internal.validation.TestMacMessagesAction" text="Test Mac Messages" />
        <action id="TreeExpandAll" internal="true" class="com.intellij.internal.tree.ExpandAll" text="Expand Tree" />
        <action id="UIDefaults" internal="true" class="com.intellij.ui.ShowUIDefaultsAction" text="LaF Defaults"/>
        <separator/>
        <action id="AddTestProcessAction" internal="true" class="com.intellij.openapi.wm.impl.status.AddTestProcessAction" text="Add Test Process"/>
        <action id="AddTestProcessActionIndefinte" internal="true" class="com.intellij.openapi.wm.impl.status.AddTestProcessActionIndefinite" text="Add Test Process Indefinite"/>
        <separator/>
        <action id="TestGestureAction" class="com.intellij.openapi.keymap.impl.ui.TestGestureAction" text="Test Gesture Action"/>
        <action id="TestDndAction" class="com.intellij.internal.validation.TestDnd" text="Test Dnd"/>
      </group>
      <group id="TopAnomalies" internal="true" class="com.intellij.internal.anomalies.TopAnomaliesAction" text="Top Anomalies" popup="true"/>
      <action id="ImageDuplicates" internal="true" class="com.intellij.internal.ShowImageDuplicatesAction" text="Find Image Duplicates"/>
      <action id="ShowNonRetinaImages" internal="true" class="com.intellij.internal.ShowNonRetinaImagesActions" text="Show Non Retina Images"/>
      <separator/>
      <reference ref="MaintenanceGroup"/>

      <action internal="true" id="SendStatistics" class="com.intellij.internal.statistic.tmp.SendStatisticsAction" text="Send statistics"/>
      <add-to-group group-id="ToolsMenu" anchor="last"/>
    </group>

    <group id="EditorContextBarMenu">
    </group>

    <group id="DirDiffMenu">
      <action id="DirDiffMenu.SetCopyToRight" class="com.intellij.openapi.diff.impl.dir.actions.popup.SetCopyToRight" text="Set Copy to Right" icon="AllIcons.Vcs.Arrow_right"/>
      <action id="DirDiffMenu.SetCopyToLeft" class="com.intellij.openapi.diff.impl.dir.actions.popup.SetCopyToLeft" text="Set Copy to Left" icon="AllIcons.Vcs.Arrow_left"/>
      <action id="DirDiffMenu.SetDelete" class="com.intellij.openapi.diff.impl.dir.actions.popup.SetDelete" text="Set Delete" icon="AllIcons.Vcs.Remove"/>
      <action id="DirDiffMenu.SetNoOperation" class="com.intellij.openapi.diff.impl.dir.actions.popup.SetNoOperation" text="Set Do Nothing"/>
      <separator/>
      <action id="DirDiffMenu.SetDefault" class="com.intellij.openapi.diff.impl.dir.actions.popup.SetDefault" text="Set Default"/>
      <action id="DirDiffMenu.WarnOnDeletion" class="com.intellij.openapi.diff.impl.dir.actions.popup.WarnOnDeletion" text="Warn When Delete" />
    </group>

    <action id="Rerun" class="com.intellij.execution.runners.FakeRerunAction" text="Rerun"/>
    <action id="RerunTests" class="com.intellij.execution.runners.RerunTestsAction" text="Rerun Tests"/>

    <action id="IncrementWindowWidth" class="com.intellij.ide.actions.WindowAction$IncrementWidth" use-shortcut-of="ResizeToolWindowRight"/>
    <action id="DecrementWindowWidth" class="com.intellij.ide.actions.WindowAction$DecrementWidth" use-shortcut-of="ResizeToolWindowLeft"/>
    <action id="IncrementWindowHeight" class="com.intellij.ide.actions.WindowAction$IncrementHeight" use-shortcut-of="ResizeToolWindowDown"/>
    <action id="DecrementWindowHeight" class="com.intellij.ide.actions.WindowAction$DecrementHeight" use-shortcut-of="ResizeToolWindowUp"/>

    <action id="ExportTestResults" class="com.intellij.execution.testframework.export.ExportTestResultsAction" icon="AllIcons.Actions.Export"/>

    <action id="SaveDocument" class="com.intellij.ide.actions.SaveDocumentAction"/>
  </actions>
</component>
